﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnderGuardLibrary;
using System.Windows.Forms;

namespace Capstone
{
    /* PARTS TAB */
    //Author: Richard Sayat
    partial class ManufacturingSystemForm
    {
        private List<PartsInfo> _partx;

        private List<PartInfo> _part;
        private List<GetAllSuppliersInfo> _Suppliers;

        UnderGuardEntityModelContainer ug = new UnderGuardEntityModelContainer();
        private int supplierId;
        private int partId;
        private int statusId;


        private void FillPartsDataGridView()
        {
            partCancelButton.Enabled = false;
            partEditSaveButton.Enabled = false;
            partEditSaveButton.Text = "Edit/Save";
            partCrudModeLabel.Text = "Viewing...";
            partGroupBox.Enabled = false;

            //gets all parts
            _partx = ug.GetPartsInfo().ToList();

            //fill the grid
            partsDataGridView.RowCount = 0;
            int row = 0;
            if (_partx.Count > 0)
            {
                partsDataGridView.Rows.Add(_partx.Count);

                foreach (PartsInfo part in _partx)
                {
                    partsDataGridView.Rows[row].Cells[0].Value = part.Part_ID;
                    partsDataGridView.Rows[row].Cells[1].Value = part.Current_Status;
                    partsDataGridView.Rows[row].Cells[2].Value = part.Part_Name;
                    partsDataGridView.Rows[row].Cells[3].Value = part.Supplier_Name;
                    row++;
                }
            }
        }


        private void PopulatePartsTab()
        {
            FillPartsDataGridView();
            //populates combo box of suppliers
            _Suppliers = ug.GetAllSuppliers().ToList();
            foreach (GetAllSuppliersInfo supplier in _Suppliers)
            {
                partSupplierComboBox.Items.Add(supplier.Supplier_Name);
            }

            //adds statuses to combo box


        }

        private void PartRowSelect(object sender, DataGridViewCellEventArgs e)
        {
            int rowcount = partsDataGridView.Rows.Count;
            //populates product name text box from selected row
            if (rowcount > 0)
            {
                partId = (int)partsDataGridView.Rows[e.RowIndex].Cells[0].Value;


                //will display all contents of part in each control
                _part = ug.GetPartInfo(partId).ToList();

                PartInfo part = _part.ElementAt(0);

                partStatusComboBox.SelectedItem = part.Current_Status;
                partSupplierComboBox.SelectedItem = part.Supplier_Name;
                partNameTextBox.Text = part.Part_Name;
                partOrderTimeMaskedTextBox.Text = part.OrderTime.ToString();
                partInvCurrentMaskedTextBox.Text = part.Quantity.ToString();
                partInvMinMaskedTextBox.Text = part.MinHoldingQuantity.ToString();

                //  partEditSaveButton.Text = "Edit";
                partEditSaveButton.Enabled = true;
                //   partCrudModeLabel.Text = "Editing";
                partCancelButton.Enabled = true;
                //   partInsertButton.Enabled = false;
                //   partGroupBox.Enabled = true;
            }
        }


        private void partStatusComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            //gets the status id
            Status status = _Statuses.ElementAt(partStatusComboBox.SelectedIndex);
            statusId = status.Status_ID;
        }

       
        private void partEditSaveButton_Click(object sender, EventArgs e)
        {
            if (partEditSaveButton.Text == "Save")
            {

                if (partStatusComboBox.SelectedIndex >= 0 && partNameTextBox.Text.Length != 0 && partSupplierComboBox.SelectedIndex >= 0 && Convert.ToInt32(partInvMinMaskedTextBox.Text) >= 0 && Convert.ToInt32(partInvCurrentMaskedTextBox.Text) >= 0)
                {
                    //inserts part to db - part name/ quantity/ supplier id
                    ug.InsertPart(partNameTextBox.Text, Convert.ToInt32(partInvCurrentMaskedTextBox.Text), Convert.ToInt32(supplierId),
                        Convert.ToInt32(statusId), Convert.ToInt32(partInvMinMaskedTextBox.Text), Convert.ToInt32(partOrderTimeMaskedTextBox.Text));

                    //refreshes the grid view
                    partsDataGridView.Rows.Clear();
                    FillPartsDataGridView();

                    partsDataGridView.Enabled = true;
                    partGroupBox.Enabled = false;
                    partInsertButton.Enabled = true;
                }
                else
                {
                    MessageBox.Show("Please make sure all fields are filled in correctly!");
                }


            }
            else if (partEditSaveButton.Text == "Edit")
            {

                if (partStatusComboBox.SelectedIndex >= 0 && partNameTextBox.Text.Length != 0 && partSupplierComboBox.SelectedIndex >= 0 && Convert.ToInt32(partInvMinMaskedTextBox.Text) >= 0 && Convert.ToInt32(partInvCurrentMaskedTextBox.Text) >= 0)
                {
                    //edits a part

                    ug.EditPart(partNameTextBox.Text, Convert.ToInt32(partInvCurrentMaskedTextBox.Text), Convert.ToInt32(supplierId),
                        Convert.ToInt32(statusId), Convert.ToInt32(partInvMinMaskedTextBox.Text), Convert.ToInt32(partOrderTimeMaskedTextBox.Text), Convert.ToInt32(partId));

                    MessageBox.Show(partNameTextBox.Text + " has been updated!");

                    
                    partsDataGridView.Rows.Clear();
                    FillPartsDataGridView();

                    partInsertButton.Enabled = true;
                    partCrudModeLabel.Text = "Viewing...";
                    partEditSaveButton.Text = "Edit/Save";
                    partsDataGridView.Enabled = true;
                    partGroupBox.Enabled = false;
                }
                else
                {
                    MessageBox.Show("Please make sure all fields are filled in correctly!");
                }


            }
            else if (partEditSaveButton.Text == "Edit/Save")
            {
                partEditSaveButton.Text = "Edit";
                partGroupBox.Enabled = true;
                partsDataGridView.Enabled = false;
                partInsertButton.Enabled = false;
                partCrudModeLabel.Text = "Editing...";

            }

        }



        
        private void partSupplierComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            //gets the supplier id of the selected supplier from combo box instead of it being based on index of combo box
            GetAllSuppliersInfo supplier = _Suppliers.ElementAt(partSupplierComboBox.SelectedIndex);
            supplierId = supplier.Supplier_ID;
        }


        private void partInsertButton_Click(object sender, EventArgs e)
        {

            partInsertButton.Enabled = false;
            partEditSaveButton.Text = "Save";
            partEditSaveButton.Enabled = true;
            partCrudModeLabel.Text = "Inserting";
            partsDataGridView.Enabled = false;
            partCancelButton.Enabled = true;
            partGroupBox.Enabled = true;


        }

        private void partCancelButton_Click(object sender, EventArgs e)
        {
            partInsertButton.Enabled = true;
            partsDataGridView.Enabled = true;
            partCrudModeLabel.Text = "Viewing...";
            partEditSaveButton.Text = "Edit/Save";
            partEditSaveButton.Enabled = false;
            partGroupBox.Enabled = false;
        }

      
    }
    
}
