﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnderGuardLibrary;
using System.Windows.Forms;

namespace Capstone
{
    /* SUPPLIERS TAB */
    //Author: Brandon Richard
    partial class ManufacturingSystemForm
    {


        UnderGuardEntityModelContainer UGC = new UnderGuardEntityModelContainer();
        List<GetAllSuppliersInfo> _supplierList;
        List<GetSupplierByID> _supplier;
        List<getAllContacts_Result> _suppContactList;
        string suppName;
        string suppPhone;
        string suppFax;
        int suppCID;
        string suppEmail;
        int suppSID;

        int suppSelectedID;

        private void FillSupplierDataGrid()
        {
            supplierCancelButton.Enabled = false;
            supplierEditSaveButton.Enabled = false;
            supplierEditSaveButton.Text = "Edit/Save";
            supplierCrudModeLabel.Text = "Viewing...";
            supplierGroupBox.Enabled = false;


            _supplierList = UGC.GetAllSuppliers().ToList();
            suppliersDataGridView.Rows.Add(_supplierList.Count);
            int row = 0;
            foreach (GetAllSuppliersInfo supplier in _supplierList)
            {
                suppliersDataGridView.Rows[row].Cells[0].Value = supplier.Supplier_ID;
                suppliersDataGridView.Rows[row].Cells[1].Value = supplier.Current_Status;
                suppliersDataGridView.Rows[row].Cells[2].Value = supplier.Supplier_Name;
                row++;
            }

            _suppContactList = UGC.getAllContacts().ToList();

            foreach (getAllContacts_Result contact in _suppContactList)
            {
                SupplierContactDDL.Items.Add(contact.Contact_Name);
            }
        }


        private void supplierInsertButton_Click(object sender, EventArgs e)
        {
            supplierInsertButton.Enabled = false;
            supplierEditSaveButton.Text = "Save";
            supplierEditSaveButton.Enabled = true;
            supplierCrudModeLabel.Text = "Inserting";
            suppliersDataGridView.Enabled = false;
            supplierCancelButton.Enabled = true;
            supplierGroupBox.Enabled = true;
        }


        private void supplierEditSaveButton_Click(object sender, EventArgs e)
        {
            if (supplierEditSaveButton.Text == "Save")
            {
                if (suppName == "" || suppPhone == "" || suppFax == "" || suppEmail == "" || SupplierContactDDL.SelectedIndex < 0)
                {
                    MessageBox.Show("Please fill in all fields!");
                }
                else
                {
                    suppliersDataGridView.Rows.Clear();
                    setFormVariables();
                    UGC.InsertSupplier(suppName, suppPhone, suppFax, suppEmail, suppCID, suppSID);
                    FillSupplierDataGrid();
                    MessageBox.Show("Record inserted!");
                    ClearSupplierForm();

                    suppliersDataGridView.Enabled = true;
                    supplierGroupBox.Enabled = false;
                    supplierInsertButton.Enabled = true;
                }
            }
            else if (supplierEditSaveButton.Text == "Edit")
            {
                if (suppName == "" || suppPhone == "" || suppFax == "" || suppEmail == "" || SupplierContactDDL.SelectedIndex < 0)
                {
                    MessageBox.Show("Please fill in all fields!");
                }
                else
                {
                    suppliersDataGridView.Rows.Clear();
                    setFormVariables();
                    UGC.UpdateSupplier(suppSelectedID, suppName, suppPhone, suppFax, suppEmail, suppCID);
                    FillSupplierDataGrid();
                    MessageBox.Show("Record inserted!");
                    ClearSupplierForm();

                    supplierInsertButton.Enabled = true;
                    supplierCrudModeLabel.Text = "Viewing...";
                    supplierEditSaveButton.Text = "Edit/Save";
                    suppliersDataGridView.Enabled = true;
                    supplierGroupBox.Enabled = false;
                }
            }
            else if (supplierEditSaveButton.Text == "Edit/Save")
            {
                supplierEditSaveButton.Text = "Edit";
                supplierGroupBox.Enabled = true;
                suppliersDataGridView.Enabled = false;
                supplierInsertButton.Enabled = false;
                supplierCrudModeLabel.Text = "Editing...";
            }
        }




        private void supplierCancelButton_Click(object sender, EventArgs e)
        {
            supplierInsertButton.Enabled = true;
            suppliersDataGridView.Enabled = true;
            supplierCrudModeLabel.Text = "Viewing...";
            supplierEditSaveButton.Text = "Edit/Save";
            supplierEditSaveButton.Enabled = false;
            supplierGroupBox.Enabled = false;
            ClearSupplierForm();
        }
        public void ClearSupplierForm()
        {
            supplierNameTextBox.Clear();
            supplierPhoneTextBox.Clear();
            supplierFaxTextBox.Clear();
            supplierEmailTextBox.Clear();
            
        }

        public void setFormVariables()
        {

            suppName = supplierNameTextBox.Text;
            suppPhone = supplierPhoneTextBox.Text;
            suppFax = supplierFaxTextBox.Text;
            suppEmail = supplierEmailTextBox.Text;
            suppCID = _suppContactList.ElementAt(SupplierContactDDL.SelectedIndex).Contact_ID;
            suppSID = supplierStatusComboBox.SelectedIndex +1;

        }
       


        private void SelectSuppRow(object sender, DataGridViewCellEventArgs e)
        {

                suppSelectedID = Convert.ToInt32(suppliersDataGridView.Rows[e.RowIndex].Cells[0].Value);
                _supplier = UGC.GetSupplierByID(suppSelectedID).ToList();
                foreach (GetSupplierByID supplier in _supplier)
                {
                    supplierStatusComboBox.SelectedIndex = supplier.Status_ID - 1;
                    supplierNameTextBox.Text = supplier.Supplier_Name;
                    supplierPhoneTextBox.Text = supplier.Phone_Number;
                    supplierFaxTextBox.Text = supplier.Fax_Number;
                    supplierEmailTextBox.Text = supplier.Email;
                    SupplierContactDDL.SelectedItem = supplier.Contact_Name;
                }

                supplierEditSaveButton.Enabled = true;
                supplierCancelButton.Enabled = true;
            
        }

    }
}
