﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace Capstone
{
    partial class MainForm
    {
        private const int _magicX = 4;
        private const int _magicY = 4;
        private ManufacturingSystemForm _manufacturingForm;
        private OrderingSystemForm _orderingForm;

        // ==========================================
        // Auto generated event stubs
        // ==========================================

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void manufacturingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StartManufacturingSystem();
        }

        private void orderingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StartOrderingSystem();
        }

        // ==========================================
        // Custom function
        // ==========================================

        private void InitManufacturingSystem()
        {
            _manufacturingForm = new ManufacturingSystemForm();
            _manufacturingForm.MdiParent = this;
        }

        private void InitOrderingSystem()
        {
            _orderingForm = new OrderingSystemForm();
            _orderingForm.MdiParent = this;
        }

        private void StartManufacturingSystem()
        {
            mainInstructionLabel.Hide();
            _orderingForm.Hide();
            orderingToolStripMenuItem.Enabled = true;

            this.ClientSize = _manufacturingForm.Size + new Size(_magicX, _magicY + mainMenuStrip.Height);
            _manufacturingForm.Show();
            _manufacturingForm.Location = new Point(0, 0);            
            manufacturingToolStripMenuItem.Enabled = false;            
            this.Text = "Underguard 2.0 - Manufacturing System";
        }

        
        private void StartOrderingSystem()
        {
            mainInstructionLabel.Hide();
            _manufacturingForm.Hide();
            manufacturingToolStripMenuItem.Enabled = true;

            this.ClientSize = _orderingForm.Size + new Size(_magicX, _magicY + mainMenuStrip.Height);
            _orderingForm.Show();
            _orderingForm.Location = new Point(0, 0);            
            orderingToolStripMenuItem.Enabled = false;            
            this.Text = "Underguard 2.0 - Ordering System";
        }
    }
}
