﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UnderGuardLibrary.DataTools;

namespace Capstone
{
    public partial class ManufacturingSystemForm : Form
    {
        //LINQ to SQL
        private List<Product_Part> _builds;
        private List<Part> _parts;
        private List<Product> _products;
        //Entity Framework
        private List<UnderGuardLibrary.Status> _Statuses;

        public ManufacturingSystemForm()
        {
            InitializeComponent();
            //set up each tab (functions defined in "their" .cs files)
            PopulateBuildSheetsTab();
            PopulatePartsTab();
            FillSupplierDataGrid();
            FillStatusComboBox();
            InitializeProductsTab();
        }
        
        private void FillStatusComboBox()
        {
            _Statuses = ug.GetAllStatuses().ToList();
            foreach (UnderGuardLibrary.Status status in _Statuses)
            {
                partStatusComboBox.Items.Add(status.Current_Status);
                supplierStatusComboBox.Items.Add(status.Current_Status);

            }
        }

        private void manufacturingSystemTabControl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (manufacturingSystemTabControl.SelectedTab == ordersTabPage)
            {
                InitializeOrdersTab();
            }
            else if (manufacturingSystemTabControl.SelectedTab == productsTabPage)
            {
                InitializeProductsTab();
            }
        }


    }
}
