﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnderGuardLibrary;
using System.Windows.Forms;

namespace Capstone
{
    /* CATALOGS TAB */
    //Author: Richard Sayat
    partial class OrderingSystemForm
    {
        UnderGuardEntityModelContainer UGC = new UnderGuardEntityModelContainer();
        List<GetAllCatalogsResult> _singleCatRecord;
        List<GetAllCatalogsInfo> _catalogList;


        int catCID;
        string catName;
        int catSID;
        //  string catSCS;
        DateTime catStartDate;
        DateTime catEndDate;
        string catDesc;

        private void FillCatalogDataGrid()
        {
            catalogCancelButton.Enabled = false;
            catalogEditSaveButton.Enabled = false;
            catalogEditSaveButton.Text = "Edit/Save";
            catalogCrudModeLabel.Text = "Viewing...";
            catalogGroupBox.Enabled = false;

            _catalogList = UGC.GetAllCatalogs().ToList();
            catalogDataGridView.Rows.Add(_catalogList.Count);
            int row = 0;
            foreach (GetAllCatalogsInfo catalog in _catalogList)
            {
                catalogDataGridView.Rows[row].Cells[0].Value = catalog.Catalog_ID;
                catalogDataGridView.Rows[row].Cells[1].Value = catalog.Current_Status;
                catalogDataGridView.Rows[row].Cells[2].Value = catalog.Catalog_Name;
                catalogDataGridView.Rows[row].Cells[3].Value = catalog.Start_Date;
                catalogDataGridView.Rows[row].Cells[4].Value = catalog.End_Date;
                row++;
            }


        }

        private void SelectCatalogRow(object sender, DataGridViewCellEventArgs e)
        {
            catCID = Convert.ToInt32(catalogDataGridView.Rows[e.RowIndex].Cells[0].Value);
            _singleCatRecord = UGC.GetCatalogByID(catCID).ToList();

            foreach (GetAllCatalogsResult catalog in _singleCatRecord)
            {
                catalogStatusComboBox.SelectedIndex = catalog.Status_ID - 1;
                catalogNameTextBox.Text = catalog.Catalog_Name;
                catalogDescriptionTextBox.Text = catalog.Description;
                catalogStartDateDateTimePicker.Value = catalog.Start_Date;
                catalogEndDateDateTimePicker.Value = catalog.End_Date;
                catalogStatusComboBox.Text = catalog.Current_Status;

                catalogEditSaveButton.Enabled = true;
                catalogCancelButton.Enabled = true;
            }
        }


        private void setCatalogVariables()
        {
            //if (catalogStatusComboBox.SelectedIndex == 0)
            //{
            //    catSID = 1;
            //}
            //else if (catalogStatusComboBox.SelectedIndex == 1)
            //{
            //    catSID = 2;
            //}
            catSID = catalogStatusComboBox.SelectedIndex + 1;
            catName = catalogNameTextBox.Text;
            catDesc = catalogDescriptionTextBox.Text;
            catStartDate = catalogStartDateDateTimePicker.Value;
            catEndDate = catalogEndDateDateTimePicker.Value;

        }

        private void clearCatalogForm()
        {
            catalogNameTextBox.Clear();
            catalogDescriptionTextBox.Clear();
        
            catalogStartDateDateTimePicker.Value = DateTime.Now;
            catalogEndDateDateTimePicker.Value = DateTime.Now;
        }

        private void catalogInsertButton_Click(object sender, EventArgs e)
        {
            clearCatalogForm();
            catalogInsertButton.Enabled = false;
            catalogEditSaveButton.Text = "Save";
            catalogEditSaveButton.Enabled = true;
            catalogCrudModeLabel.Text = "Inserting";
            catalogDataGridView.Enabled = false;
            catalogCancelButton.Enabled = true;
            catalogGroupBox.Enabled = true;
        }

        #pragma warning disable
        private void catalogEditSaveButton_Click(object sender, EventArgs e)
        {
            if (catalogEditSaveButton.Text == "Save")
            {
                if (catName == "" || catDesc == "" || catStartDate == null || catEndDate == null || catSID == null)
                {
                    MessageBox.Show("Please fill in all fields!");
                }
                else
                {
                    catalogDataGridView.Rows.Clear();
                    setCatalogVariables();
                    UGC.InsertCatalog(catName, catSID, catStartDate, catEndDate, catDesc);
                    FillCatalogDataGrid();
                    MessageBox.Show("Record inserted!");
                    clearCatalogForm();

                    catalogDataGridView.Enabled = true;
                    catalogGroupBox.Enabled = false;
                    catalogInsertButton.Enabled = true;

                }
            }
            else if (catalogEditSaveButton.Text == "Edit")
            {
                if (catName == "" || catDesc == "" || catStartDate == null || catEndDate == null || catSID == null)
                {
                    MessageBox.Show("Please fill in all fields!");
                }
                else
                {
                    catalogDataGridView.Rows.Clear();
                    setCatalogVariables();
                    UGC.UpdateCatalog(catCID, catName, catSID, catStartDate, catEndDate, catDesc);
                    FillCatalogDataGrid();
                    MessageBox.Show("Record inserted!");
                    clearCatalogForm();


                    catalogInsertButton.Enabled = true;
                    catalogCrudModeLabel.Text = "Viewing...";
                    catalogEditSaveButton.Text = "Edit/Save";
                    catalogDataGridView.Enabled = true;
                    catalogGroupBox.Enabled = false;
                }
            }
            else if (catalogEditSaveButton.Text == "Edit/Save")
            {
                catalogEditSaveButton.Text = "Edit";
                catalogGroupBox.Enabled = true;
                catalogDataGridView.Enabled = false;
                catalogInsertButton.Enabled = false;
                catalogCrudModeLabel.Text = "Editing...";
            }
        }

        private void catalogCancelButton_Click(object sender, EventArgs e)
        {
            catalogInsertButton.Enabled = true;
            catalogDataGridView.Enabled = true;
            catalogCrudModeLabel.Text = "Viewing...";
            catalogEditSaveButton.Text = "Edit/Save";
            catalogEditSaveButton.Enabled = false;
            catalogGroupBox.Enabled = false;
            clearCatalogForm();
        }

        private void catalogStatusComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Status status = _Statuses.ElementAt(catalogStatusComboBox.SelectedIndex);
            catSID = status.Status_ID;
        }
        #pragma warning restore

    }
}
