﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnderGuardLibrary;
using System.Windows.Forms;

namespace Capstone
{
    /* CATEGORIES TAB */
    //Author: Richard Sayat
    partial class OrderingSystemForm
    {

        UnderGuardEntityModelContainer ug = new UnderGuardEntityModelContainer();
        List<Category> _CategoryInfo;
        List<Category> _Category;

        private int categoryId;


        private void FillCategoriesDataGridView()
        {

            categoryCancelButton.Enabled = false;
            categoryEditSaveButton.Enabled = false;
            categoryEditSaveButton.Text = "Edit/Save";
            categoryCrudModeLabel.Text = "Viewing...";
            categoryGroupBox.Enabled = false;

            _CategoryInfo = ug.GetAllCategories().ToList();

            categoryDataGridView.Rows.Add(_CategoryInfo.Count);
            int row = 0;

            foreach (Category category in _CategoryInfo)
            {
                categoryDataGridView.Rows[row].Cells[0].Value = category.Category_ID;
                categoryDataGridView.Rows[row].Cells[1].Value = category.Category_Name;
                row++;
            }
        }

        private void FillCategoriesTab()
        {
            FillCategoriesDataGridView();
        }


        private void SelectCategoryRow(object sender, DataGridViewCellEventArgs e)
        {
                categoryId = (int)categoryDataGridView.Rows[e.RowIndex].Cells[0].Value;

                //   partNameTextBox.Text = partId.ToString();
                //will display all contents of categories in each control
                _Category = ug.GetCategory(categoryId).ToList();


                Category category = _Category.ElementAt(0);

                categoryNameTextBox.Text = category.Category_Name;

                categoryEditSaveButton.Enabled = true;
                categoryCancelButton.Enabled = true;

        }
      
        private void categoryInsertButton_Click(object sender, EventArgs e)
        {
            categoryInsertButton.Enabled = false;
            categoryEditSaveButton.Text = "Save";
            categoryEditSaveButton.Enabled = true;
            categoryCrudModeLabel.Text = "Inserting";
            categoryDataGridView.Enabled = false;
            categoryCancelButton.Enabled = true;
            categoryGroupBox.Enabled = true;
        }

        private void categoryEditSaveButton_Click(object sender, EventArgs e)
        {
            if (categoryEditSaveButton.Text == "Save")
            {

                if (categoryNameTextBox.Text.Length != 0)
                {
                    //inserts part to db - part name/ quantity/ supplier id
                    ug.InsertCategory(categoryNameTextBox.Text);

                    //refreshes the grid view
                    categoryDataGridView.Rows.Clear();
                    FillCategoriesDataGridView();

                    categoryDataGridView.Enabled = true;
                    categoryGroupBox.Enabled = false;
                    categoryInsertButton.Enabled = true;
                }
                else
                {
                    MessageBox.Show("Please make sure all fields are filled in correctly!");
                }


            }
            else if (categoryEditSaveButton.Text == "Edit")
            {

                if (categoryNameTextBox.Text.Length != 0)
                {
                    //edits a category
                    ug.EditCategory(categoryNameTextBox.Text, categoryId);
                    //refreshes the grid view
                    categoryDataGridView.Rows.Clear();
                    FillCategoriesDataGridView();

                    categoryInsertButton.Enabled = true;
                    categoryCrudModeLabel.Text = "Viewing...";
                    categoryEditSaveButton.Text = "Edit/Save";
                    categoryDataGridView.Enabled = true;
                    categoryGroupBox.Enabled = false;
                }
                else
                {
                    MessageBox.Show("Please make sure all fields are filled in correctly!");
                }
            }
            else if (categoryEditSaveButton.Text == "Edit/Save")
            {
                categoryEditSaveButton.Text = "Edit";
                categoryGroupBox.Enabled = true;
                categoryDataGridView.Enabled = false;
                categoryInsertButton.Enabled = false;
                categoryCrudModeLabel.Text = "Editing...";
            }
        }

        private void categoryCancelButton_Click(object sender, EventArgs e)
        {
            categoryInsertButton.Enabled = true;
            categoryDataGridView.Enabled = true;
            categoryCrudModeLabel.Text = "Viewing...";
            categoryEditSaveButton.Text = "Edit/Save";
            categoryEditSaveButton.Enabled = false;
            categoryGroupBox.Enabled = false;
        }

       




    }
}
