﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using UnderGuardLibrary.DataTools;

namespace Capstone
{
    public partial class OrderingSystemForm : Form
    {
        //LINQ to SQL
        private List<Client> _clients;
        private List<Contact> _contacts;
        private List<Client_Contact> _clientContacts;
        private DataClassesDataContext dc;
        //Entity Framework
        private List<UnderGuardLibrary.Status> _Statuses;

        public OrderingSystemForm()
        {
            InitializeComponent();
            dc = new DataClassesDataContext();
            //set up each tab (functions defined in "their" .cs files)
            PopulateClientsTab();
            PopulateContactsTab();
            FillStatusComboBox();
            FillCategoriesTab();
            FillCatalogDataGrid();
        }

        private void FillStatusComboBox()
        {
            _Statuses = ug.GetAllStatuses().ToList();
            foreach (UnderGuardLibrary.Status status in _Statuses)
            {
                catalogStatusComboBox.Items.Add(status.Current_Status);
            }
        }

        private void orderingSystemTabControl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (orderingSystemTabControl.SelectedTab == ordersTabPage)
            {
                InitializeOrdersTab();
            }

            if (orderingSystemTabControl.SelectedTab == clientsTabPage)
            {
                PopulateClientsTab();            
            }
        }
    }
}
