
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 03/07/2013 13:30:52
-- Generated from EDMX file: C:\Users\Richard Sayat\Desktop\Capstone Repository\capstone2013\UnderGuardLibrary\UnderGuardEntityModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [UnderGuardDb];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_ProductProduct_Part]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Part] DROP CONSTRAINT [FK_ProductProduct_Part];
GO
IF OBJECT_ID(N'[dbo].[FK_PartProduct_Part]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Part] DROP CONSTRAINT [FK_PartProduct_Part];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductProduct_Category]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Category] DROP CONSTRAINT [FK_ProductProduct_Category];
GO
IF OBJECT_ID(N'[dbo].[FK_CategoryProduct_Category]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Category] DROP CONSTRAINT [FK_CategoryProduct_Category];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductProduct_Catalog]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Catalog] DROP CONSTRAINT [FK_ProductProduct_Catalog];
GO
IF OBJECT_ID(N'[dbo].[FK_CatalogProduct_Catalog]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Product_Catalog] DROP CONSTRAINT [FK_CatalogProduct_Catalog];
GO
IF OBJECT_ID(N'[dbo].[FK_CatalogStatus]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Catalogs] DROP CONSTRAINT [FK_CatalogStatus];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductStatus]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Products] DROP CONSTRAINT [FK_ProductStatus];
GO
IF OBJECT_ID(N'[dbo].[FK_ProductOrder_Product]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Order_Product] DROP CONSTRAINT [FK_ProductOrder_Product];
GO
IF OBJECT_ID(N'[dbo].[FK_OrderOrder_Product]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Order_Product] DROP CONSTRAINT [FK_OrderOrder_Product];
GO
IF OBJECT_ID(N'[dbo].[FK_ClientClient_Contact]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Client_Contact] DROP CONSTRAINT [FK_ClientClient_Contact];
GO
IF OBJECT_ID(N'[dbo].[FK_ContactClient_Contact]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Client_Contact] DROP CONSTRAINT [FK_ContactClient_Contact];
GO
IF OBJECT_ID(N'[dbo].[FK_OrderClient]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Orders] DROP CONSTRAINT [FK_OrderClient];
GO
IF OBJECT_ID(N'[dbo].[FK_OrderStatus]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Orders] DROP CONSTRAINT [FK_OrderStatus];
GO
IF OBJECT_ID(N'[dbo].[FK_SupplierContact]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Suppliers] DROP CONSTRAINT [FK_SupplierContact];
GO
IF OBJECT_ID(N'[dbo].[FK_ContactAddress]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Contacts] DROP CONSTRAINT [FK_ContactAddress];
GO
IF OBJECT_ID(N'[dbo].[FK_ClientClient_Address]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Client_Address] DROP CONSTRAINT [FK_ClientClient_Address];
GO
IF OBJECT_ID(N'[dbo].[FK_AddressClient_Address]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Client_Address] DROP CONSTRAINT [FK_AddressClient_Address];
GO
IF OBJECT_ID(N'[dbo].[FK_SupplierPart]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Parts] DROP CONSTRAINT [FK_SupplierPart];
GO
IF OBJECT_ID(N'[dbo].[FK_PartStatus]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Parts] DROP CONSTRAINT [FK_PartStatus];
GO
IF OBJECT_ID(N'[dbo].[FK_SupplierStatus]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Suppliers] DROP CONSTRAINT [FK_SupplierStatus];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Products]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Products];
GO
IF OBJECT_ID(N'[dbo].[Parts]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Parts];
GO
IF OBJECT_ID(N'[dbo].[Product_Part]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Product_Part];
GO
IF OBJECT_ID(N'[dbo].[Status]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Status];
GO
IF OBJECT_ID(N'[dbo].[Product_Category]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Product_Category];
GO
IF OBJECT_ID(N'[dbo].[Categories]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Categories];
GO
IF OBJECT_ID(N'[dbo].[Product_Catalog]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Product_Catalog];
GO
IF OBJECT_ID(N'[dbo].[Catalogs]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Catalogs];
GO
IF OBJECT_ID(N'[dbo].[Order_Product]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Order_Product];
GO
IF OBJECT_ID(N'[dbo].[Orders]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Orders];
GO
IF OBJECT_ID(N'[dbo].[Clients]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Clients];
GO
IF OBJECT_ID(N'[dbo].[Client_Contact]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Client_Contact];
GO
IF OBJECT_ID(N'[dbo].[Contacts]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Contacts];
GO
IF OBJECT_ID(N'[dbo].[Addresses]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Addresses];
GO
IF OBJECT_ID(N'[dbo].[Suppliers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Suppliers];
GO
IF OBJECT_ID(N'[dbo].[Client_Address]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Client_Address];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Products'
CREATE TABLE [dbo].[Products] (
    [Product_ID] int IDENTITY(1,1) NOT NULL,
    [Product_Name] nvarchar(max)  NOT NULL,
    [Product_Description] nvarchar(max)  NOT NULL,
    [Manufacturing_Time] int  NOT NULL,
    [Status_ID] int  NOT NULL,
    [Image_Path] nvarchar(max)  NOT NULL,
    [Price] float  NOT NULL,
    [Status_Status_ID] int  NOT NULL
);
GO

-- Creating table 'Parts'
CREATE TABLE [dbo].[Parts] (
    [Part_ID] int IDENTITY(1,1) NOT NULL,
    [Part_Name] nvarchar(max)  NOT NULL,
    [Quantity] int  NOT NULL,
    [Supplier_ID] int  NOT NULL,
    [Status_ID] int  NOT NULL,
    [MinHoldingQuantity] int  NOT NULL,
    [OrderTime] float  NOT NULL,
    [Status_Status_ID] int  NOT NULL
);
GO

-- Creating table 'Product_Part'
CREATE TABLE [dbo].[Product_Part] (
    [Product_Part_ID] int IDENTITY(1,1) NOT NULL,
    [Product_ID] int  NOT NULL,
    [Part_ID] int  NOT NULL,
    [Quantity] int  NOT NULL
);
GO

-- Creating table 'Status'
CREATE TABLE [dbo].[Status] (
    [Status_ID] int IDENTITY(1,1) NOT NULL,
    [Current_Status] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Product_Category'
CREATE TABLE [dbo].[Product_Category] (
    [Product_Category_ID] int IDENTITY(1,1) NOT NULL,
    [Product_ID] int  NOT NULL,
    [Category_ID] int  NOT NULL
);
GO

-- Creating table 'Categories'
CREATE TABLE [dbo].[Categories] (
    [Category_ID] int IDENTITY(1,1) NOT NULL,
    [Category_Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Product_Catalog'
CREATE TABLE [dbo].[Product_Catalog] (
    [Product_Catalog_ID] int IDENTITY(1,1) NOT NULL,
    [Product_ID] int  NOT NULL,
    [Catalog_ID] int  NOT NULL
);
GO

-- Creating table 'Catalogs'
CREATE TABLE [dbo].[Catalogs] (
    [Catalog_ID] int IDENTITY(1,1) NOT NULL,
    [Catalog_Name] nvarchar(max)  NOT NULL,
    [Status_ID] int  NOT NULL,
    [Start_Date] datetime  NOT NULL,
    [End_Date] datetime  NOT NULL,
    [Status_Status_ID] int  NOT NULL
);
GO

-- Creating table 'Order_Product'
CREATE TABLE [dbo].[Order_Product] (
    [Order_Product_ID] int IDENTITY(1,1) NOT NULL,
    [Product_ID] int  NOT NULL,
    [Order_ID] int  NOT NULL
);
GO

-- Creating table 'Orders'
CREATE TABLE [dbo].[Orders] (
    [Order_ID] int IDENTITY(1,1) NOT NULL,
    [Client_ID] int  NOT NULL,
    [Date] datetime  NOT NULL,
    [Client_Client_ID] int  NOT NULL,
    [Status_Status_ID] int  NOT NULL
);
GO

-- Creating table 'Clients'
CREATE TABLE [dbo].[Clients] (
    [Client_ID] int IDENTITY(1,1) NOT NULL,
    [Client_Name] nvarchar(max)  NOT NULL,
    [Billing_Address] int  NOT NULL,
    [Shipping_Address] int  NOT NULL
);
GO

-- Creating table 'Client_Contact'
CREATE TABLE [dbo].[Client_Contact] (
    [Client_Contact_ID] int IDENTITY(1,1) NOT NULL,
    [Client_ID] int  NOT NULL,
    [Contact_ID] int  NOT NULL
);
GO

-- Creating table 'Contacts'
CREATE TABLE [dbo].[Contacts] (
    [Contact_ID] int IDENTITY(1,1) NOT NULL,
    [Contact_Name] nvarchar(max)  NOT NULL,
    [Email] nvarchar(max)  NOT NULL,
    [Phone_Number] nvarchar(max)  NOT NULL,
    [Fax_Number] nvarchar(max)  NULL,
    [Notes] nvarchar(max)  NULL,
    [Address_ID] int  NOT NULL,
    [Address_Address_ID] int  NOT NULL
);
GO

-- Creating table 'Addresses'
CREATE TABLE [dbo].[Addresses] (
    [Address_ID] int IDENTITY(1,1) NOT NULL,
    [Civic_Address] nvarchar(max)  NOT NULL,
    [City] nvarchar(max)  NOT NULL,
    [Province] nvarchar(max)  NOT NULL,
    [Postal_Code] nvarchar(max)  NOT NULL,
    [Address_Type] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Suppliers'
CREATE TABLE [dbo].[Suppliers] (
    [Supplier_ID] int IDENTITY(1,1) NOT NULL,
    [Supplier_Name] nvarchar(max)  NOT NULL,
    [Phone_Number] nvarchar(max)  NOT NULL,
    [Fax_Number] nvarchar(max)  NULL,
    [Email] nvarchar(max)  NOT NULL,
    [Contact_ID] int  NOT NULL,
    [Status_ID] int  NOT NULL,
    [Contact_Contact_ID] int  NOT NULL,
    [Status_Status_ID] int  NOT NULL
);
GO

-- Creating table 'Client_Address'
CREATE TABLE [dbo].[Client_Address] (
    [Client_Address_ID] int IDENTITY(1,1) NOT NULL,
    [Client_ID] int  NOT NULL,
    [Address_ID] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Product_ID] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [PK_Products]
    PRIMARY KEY CLUSTERED ([Product_ID] ASC);
GO

-- Creating primary key on [Part_ID] in table 'Parts'
ALTER TABLE [dbo].[Parts]
ADD CONSTRAINT [PK_Parts]
    PRIMARY KEY CLUSTERED ([Part_ID] ASC);
GO

-- Creating primary key on [Product_Part_ID] in table 'Product_Part'
ALTER TABLE [dbo].[Product_Part]
ADD CONSTRAINT [PK_Product_Part]
    PRIMARY KEY CLUSTERED ([Product_Part_ID] ASC);
GO

-- Creating primary key on [Status_ID] in table 'Status'
ALTER TABLE [dbo].[Status]
ADD CONSTRAINT [PK_Status]
    PRIMARY KEY CLUSTERED ([Status_ID] ASC);
GO

-- Creating primary key on [Product_Category_ID] in table 'Product_Category'
ALTER TABLE [dbo].[Product_Category]
ADD CONSTRAINT [PK_Product_Category]
    PRIMARY KEY CLUSTERED ([Product_Category_ID] ASC);
GO

-- Creating primary key on [Category_ID] in table 'Categories'
ALTER TABLE [dbo].[Categories]
ADD CONSTRAINT [PK_Categories]
    PRIMARY KEY CLUSTERED ([Category_ID] ASC);
GO

-- Creating primary key on [Product_Catalog_ID] in table 'Product_Catalog'
ALTER TABLE [dbo].[Product_Catalog]
ADD CONSTRAINT [PK_Product_Catalog]
    PRIMARY KEY CLUSTERED ([Product_Catalog_ID] ASC);
GO

-- Creating primary key on [Catalog_ID] in table 'Catalogs'
ALTER TABLE [dbo].[Catalogs]
ADD CONSTRAINT [PK_Catalogs]
    PRIMARY KEY CLUSTERED ([Catalog_ID] ASC);
GO

-- Creating primary key on [Order_Product_ID] in table 'Order_Product'
ALTER TABLE [dbo].[Order_Product]
ADD CONSTRAINT [PK_Order_Product]
    PRIMARY KEY CLUSTERED ([Order_Product_ID] ASC);
GO

-- Creating primary key on [Order_ID] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [PK_Orders]
    PRIMARY KEY CLUSTERED ([Order_ID] ASC);
GO

-- Creating primary key on [Client_ID] in table 'Clients'
ALTER TABLE [dbo].[Clients]
ADD CONSTRAINT [PK_Clients]
    PRIMARY KEY CLUSTERED ([Client_ID] ASC);
GO

-- Creating primary key on [Client_Contact_ID] in table 'Client_Contact'
ALTER TABLE [dbo].[Client_Contact]
ADD CONSTRAINT [PK_Client_Contact]
    PRIMARY KEY CLUSTERED ([Client_Contact_ID] ASC);
GO

-- Creating primary key on [Contact_ID] in table 'Contacts'
ALTER TABLE [dbo].[Contacts]
ADD CONSTRAINT [PK_Contacts]
    PRIMARY KEY CLUSTERED ([Contact_ID] ASC);
GO

-- Creating primary key on [Address_ID] in table 'Addresses'
ALTER TABLE [dbo].[Addresses]
ADD CONSTRAINT [PK_Addresses]
    PRIMARY KEY CLUSTERED ([Address_ID] ASC);
GO

-- Creating primary key on [Supplier_ID] in table 'Suppliers'
ALTER TABLE [dbo].[Suppliers]
ADD CONSTRAINT [PK_Suppliers]
    PRIMARY KEY CLUSTERED ([Supplier_ID] ASC);
GO

-- Creating primary key on [Client_Address_ID] in table 'Client_Address'
ALTER TABLE [dbo].[Client_Address]
ADD CONSTRAINT [PK_Client_Address]
    PRIMARY KEY CLUSTERED ([Client_Address_ID] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Product_ID] in table 'Product_Part'
ALTER TABLE [dbo].[Product_Part]
ADD CONSTRAINT [FK_ProductProduct_Part]
    FOREIGN KEY ([Product_ID])
    REFERENCES [dbo].[Products]
        ([Product_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductProduct_Part'
CREATE INDEX [IX_FK_ProductProduct_Part]
ON [dbo].[Product_Part]
    ([Product_ID]);
GO

-- Creating foreign key on [Part_ID] in table 'Product_Part'
ALTER TABLE [dbo].[Product_Part]
ADD CONSTRAINT [FK_PartProduct_Part]
    FOREIGN KEY ([Part_ID])
    REFERENCES [dbo].[Parts]
        ([Part_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PartProduct_Part'
CREATE INDEX [IX_FK_PartProduct_Part]
ON [dbo].[Product_Part]
    ([Part_ID]);
GO

-- Creating foreign key on [Product_ID] in table 'Product_Category'
ALTER TABLE [dbo].[Product_Category]
ADD CONSTRAINT [FK_ProductProduct_Category]
    FOREIGN KEY ([Product_ID])
    REFERENCES [dbo].[Products]
        ([Product_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductProduct_Category'
CREATE INDEX [IX_FK_ProductProduct_Category]
ON [dbo].[Product_Category]
    ([Product_ID]);
GO

-- Creating foreign key on [Category_ID] in table 'Product_Category'
ALTER TABLE [dbo].[Product_Category]
ADD CONSTRAINT [FK_CategoryProduct_Category]
    FOREIGN KEY ([Category_ID])
    REFERENCES [dbo].[Categories]
        ([Category_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CategoryProduct_Category'
CREATE INDEX [IX_FK_CategoryProduct_Category]
ON [dbo].[Product_Category]
    ([Category_ID]);
GO

-- Creating foreign key on [Product_ID] in table 'Product_Catalog'
ALTER TABLE [dbo].[Product_Catalog]
ADD CONSTRAINT [FK_ProductProduct_Catalog]
    FOREIGN KEY ([Product_ID])
    REFERENCES [dbo].[Products]
        ([Product_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductProduct_Catalog'
CREATE INDEX [IX_FK_ProductProduct_Catalog]
ON [dbo].[Product_Catalog]
    ([Product_ID]);
GO

-- Creating foreign key on [Catalog_ID] in table 'Product_Catalog'
ALTER TABLE [dbo].[Product_Catalog]
ADD CONSTRAINT [FK_CatalogProduct_Catalog]
    FOREIGN KEY ([Catalog_ID])
    REFERENCES [dbo].[Catalogs]
        ([Catalog_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CatalogProduct_Catalog'
CREATE INDEX [IX_FK_CatalogProduct_Catalog]
ON [dbo].[Product_Catalog]
    ([Catalog_ID]);
GO

-- Creating foreign key on [Status_Status_ID] in table 'Catalogs'
ALTER TABLE [dbo].[Catalogs]
ADD CONSTRAINT [FK_CatalogStatus]
    FOREIGN KEY ([Status_Status_ID])
    REFERENCES [dbo].[Status]
        ([Status_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CatalogStatus'
CREATE INDEX [IX_FK_CatalogStatus]
ON [dbo].[Catalogs]
    ([Status_Status_ID]);
GO

-- Creating foreign key on [Status_Status_ID] in table 'Products'
ALTER TABLE [dbo].[Products]
ADD CONSTRAINT [FK_ProductStatus]
    FOREIGN KEY ([Status_Status_ID])
    REFERENCES [dbo].[Status]
        ([Status_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductStatus'
CREATE INDEX [IX_FK_ProductStatus]
ON [dbo].[Products]
    ([Status_Status_ID]);
GO

-- Creating foreign key on [Product_ID] in table 'Order_Product'
ALTER TABLE [dbo].[Order_Product]
ADD CONSTRAINT [FK_ProductOrder_Product]
    FOREIGN KEY ([Product_ID])
    REFERENCES [dbo].[Products]
        ([Product_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ProductOrder_Product'
CREATE INDEX [IX_FK_ProductOrder_Product]
ON [dbo].[Order_Product]
    ([Product_ID]);
GO

-- Creating foreign key on [Order_ID] in table 'Order_Product'
ALTER TABLE [dbo].[Order_Product]
ADD CONSTRAINT [FK_OrderOrder_Product]
    FOREIGN KEY ([Order_ID])
    REFERENCES [dbo].[Orders]
        ([Order_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrderOrder_Product'
CREATE INDEX [IX_FK_OrderOrder_Product]
ON [dbo].[Order_Product]
    ([Order_ID]);
GO

-- Creating foreign key on [Client_ID] in table 'Client_Contact'
ALTER TABLE [dbo].[Client_Contact]
ADD CONSTRAINT [FK_ClientClient_Contact]
    FOREIGN KEY ([Client_ID])
    REFERENCES [dbo].[Clients]
        ([Client_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ClientClient_Contact'
CREATE INDEX [IX_FK_ClientClient_Contact]
ON [dbo].[Client_Contact]
    ([Client_ID]);
GO

-- Creating foreign key on [Contact_ID] in table 'Client_Contact'
ALTER TABLE [dbo].[Client_Contact]
ADD CONSTRAINT [FK_ContactClient_Contact]
    FOREIGN KEY ([Contact_ID])
    REFERENCES [dbo].[Contacts]
        ([Contact_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ContactClient_Contact'
CREATE INDEX [IX_FK_ContactClient_Contact]
ON [dbo].[Client_Contact]
    ([Contact_ID]);
GO

-- Creating foreign key on [Client_Client_ID] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [FK_OrderClient]
    FOREIGN KEY ([Client_Client_ID])
    REFERENCES [dbo].[Clients]
        ([Client_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrderClient'
CREATE INDEX [IX_FK_OrderClient]
ON [dbo].[Orders]
    ([Client_Client_ID]);
GO

-- Creating foreign key on [Status_Status_ID] in table 'Orders'
ALTER TABLE [dbo].[Orders]
ADD CONSTRAINT [FK_OrderStatus]
    FOREIGN KEY ([Status_Status_ID])
    REFERENCES [dbo].[Status]
        ([Status_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrderStatus'
CREATE INDEX [IX_FK_OrderStatus]
ON [dbo].[Orders]
    ([Status_Status_ID]);
GO

-- Creating foreign key on [Contact_Contact_ID] in table 'Suppliers'
ALTER TABLE [dbo].[Suppliers]
ADD CONSTRAINT [FK_SupplierContact]
    FOREIGN KEY ([Contact_Contact_ID])
    REFERENCES [dbo].[Contacts]
        ([Contact_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SupplierContact'
CREATE INDEX [IX_FK_SupplierContact]
ON [dbo].[Suppliers]
    ([Contact_Contact_ID]);
GO

-- Creating foreign key on [Address_Address_ID] in table 'Contacts'
ALTER TABLE [dbo].[Contacts]
ADD CONSTRAINT [FK_ContactAddress]
    FOREIGN KEY ([Address_Address_ID])
    REFERENCES [dbo].[Addresses]
        ([Address_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ContactAddress'
CREATE INDEX [IX_FK_ContactAddress]
ON [dbo].[Contacts]
    ([Address_Address_ID]);
GO

-- Creating foreign key on [Client_ID] in table 'Client_Address'
ALTER TABLE [dbo].[Client_Address]
ADD CONSTRAINT [FK_ClientClient_Address]
    FOREIGN KEY ([Client_ID])
    REFERENCES [dbo].[Clients]
        ([Client_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_ClientClient_Address'
CREATE INDEX [IX_FK_ClientClient_Address]
ON [dbo].[Client_Address]
    ([Client_ID]);
GO

-- Creating foreign key on [Address_ID] in table 'Client_Address'
ALTER TABLE [dbo].[Client_Address]
ADD CONSTRAINT [FK_AddressClient_Address]
    FOREIGN KEY ([Address_ID])
    REFERENCES [dbo].[Addresses]
        ([Address_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_AddressClient_Address'
CREATE INDEX [IX_FK_AddressClient_Address]
ON [dbo].[Client_Address]
    ([Address_ID]);
GO

-- Creating foreign key on [Supplier_ID] in table 'Parts'
ALTER TABLE [dbo].[Parts]
ADD CONSTRAINT [FK_SupplierPart]
    FOREIGN KEY ([Supplier_ID])
    REFERENCES [dbo].[Suppliers]
        ([Supplier_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SupplierPart'
CREATE INDEX [IX_FK_SupplierPart]
ON [dbo].[Parts]
    ([Supplier_ID]);
GO

-- Creating foreign key on [Status_Status_ID] in table 'Parts'
ALTER TABLE [dbo].[Parts]
ADD CONSTRAINT [FK_PartStatus]
    FOREIGN KEY ([Status_Status_ID])
    REFERENCES [dbo].[Status]
        ([Status_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PartStatus'
CREATE INDEX [IX_FK_PartStatus]
ON [dbo].[Parts]
    ([Status_Status_ID]);
GO

-- Creating foreign key on [Status_Status_ID] in table 'Suppliers'
ALTER TABLE [dbo].[Suppliers]
ADD CONSTRAINT [FK_SupplierStatus]
    FOREIGN KEY ([Status_Status_ID])
    REFERENCES [dbo].[Status]
        ([Status_ID])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_SupplierStatus'
CREATE INDEX [IX_FK_SupplierStatus]
ON [dbo].[Suppliers]
    ([Status_Status_ID]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------