﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.Account
{
    public partial class Register : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            RegisterUser.ContinueDestinationPageUrl = Request.QueryString["ReturnUrl"];
        }

        protected void RegisterUser_CreatedUser(object sender, EventArgs e)
        {
            //sets new user to be authorized for session (auto-generated)
            FormsAuthentication.SetAuthCookie(RegisterUser.UserName, false /* createPersistentCookie */);

            //this should be OK, since the user doesn't have a role by default
            Roles.AddUserToRole(RegisterUser.UserName, "New User");

            //save user to database
            _dc.saveUser(RegisterUser.UserName);

            //save description
            TextBox descriptionTextBox = RegisterUser.CreateUserStep.ContentTemplateContainer.FindControl("DescriptionTextBox") as TextBox;
            string description = descriptionTextBox.Text;
            if (description != string.Empty)
            {
                _dc.updateUserDescription(RegisterUser.UserName, description);
            }

            //move on (auto-generated)
            string continueUrl = RegisterUser.ContinueDestinationPageUrl;
            if (String.IsNullOrEmpty(continueUrl))
            {
                continueUrl = "~/";
            }
            Response.Redirect(continueUrl);
        }

    }
}
