﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.AdminPages
{
    public partial class UserManager : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            string register = Request["register"];
            string suspend = Request["suspend"];
            string delete = Request["delete"];

            //do any registering
            if (register != null)
            {
                Users_Client userRecord = _dc.getWebUser(register).Single();
                if (userRecord.ClientID != null)
                {
                    try
                    {
                        Roles.AddUserToRole(register, "Registered User");
                    }
                    catch { }

                    try
                    {
                        Roles.RemoveUserFromRole(register, "New User");
                    }
                    catch { }
                }
                else
                {
                    MessageLabel.Text = "Associate the user with a client account first.";                
                }
            }
            //do any suspending
            if (suspend != null)
            {
                try
                {
                    Roles.RemoveUserFromRole(suspend, "New User");                
                }
                catch{}

                try
                {
                    Roles.RemoveUserFromRole(suspend, "Registered User");                
                }
                catch{}
            }
            //do any deleting
            if (delete != null)
            {
                //delete from asp.net users
                Membership.DeleteUser(delete);

                //delete from client_users "join"
                _dc.deleteWebUser(delete);
            }

            //show checkboxes for registered users
            for (int i = 0; i < UsersGridView.Rows.Count; i++ )
            {
                string userName = UsersGridView.Rows[i].Cells[2].Text;
                List<string> userRoles = Roles.FindUsersInRole("Registered User",userName).ToList();
                foreach (string role in userRoles)
                {
                    if (userName == role)
                    {
                        CheckBox registeredCheck = (CheckBox)UsersGridView.Rows[i].Cells[3].FindControl("RegisteredCheckBox");
                        registeredCheck.Checked = true;
                    }
                }
            }
        }
    }
}