﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using CapstoneWebApplication.ServiceReference1;
using System.Data;

namespace CapstoneWebApplication
{
    public partial class Products : System.Web.UI.Page
    {
        protected List<Product> products;

        protected void Page_Load(object sender, EventArgs e)
        {
                products = (new WebServiceSoapClient()).GetTop10ProductsFromMostRecentCatalog().ToList<Product>();
                GridView_Products.DataSource = products;

                GridView_Products.DataSource = products;
                GridView_Products.AllowPaging = true;
                GridView_Products.PageSize = 5;
                GridView_Products.DataBind();

                GridView_Products.DataBind();
        }

        private void ConvertSortDirectionToSql(SortDirection sortDirection)
        {
        }

        protected void gridView_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            GridView_Products.PageIndex = e.NewPageIndex;
            GridView_Products.DataBind();
        }

        protected void gridView_Sorting(object sender, GridViewSortEventArgs e)
        {
        }

        protected void Button_Search_Click(object sender, EventArgs e)
        {
            WebServiceSoapClient webServiceClient = new WebServiceSoapClient();

            if (DropDownList_FilterBy.SelectedValue == "ID")
            {
                int idSearch;
                if (!int.TryParse(TextBox_FilterBy.Text, out idSearch))
                {
                    TextBox_FilterBy.Text = "3";                
                }

                products = webServiceClient.GetProductById(
                    Convert.ToInt32(TextBox_FilterBy.Text), 
                    Convert.ToInt32(DropDownList_Catalog.SelectedValue), 
                    Convert.ToInt32(DropDownList_Category.SelectedValue)).ToList<Product>();
            }
            else if (DropDownList_FilterBy.SelectedValue == "Name")
            {
                products = webServiceClient.GetProductByName(
                    TextBox_FilterBy.Text,
                    Convert.ToInt32(DropDownList_Catalog.SelectedValue),
                    Convert.ToInt32(DropDownList_Category.SelectedValue)).ToList<Product>();
            }
            else if (DropDownList_FilterBy.SelectedValue == "Description")
            {
                products = webServiceClient.GetProductByDescription(
                    TextBox_FilterBy.Text,
                    Convert.ToInt32(DropDownList_Catalog.SelectedValue),
                    Convert.ToInt32(DropDownList_Category.SelectedValue)).ToList<Product>();
            }
            else if (DropDownList_FilterBy.SelectedValue == "Status")
            {
                products = webServiceClient.GetProductByStatus(
                    TextBox_FilterBy.Text,
                    Convert.ToInt32(DropDownList_Catalog.SelectedValue),
                    Convert.ToInt32(DropDownList_Category.SelectedValue)).ToList<Product>();
            }
            else //price
            {
                products = webServiceClient.GetProductByPrice(
                    (float)Convert.ToDouble(TextBox_FilterBy.Text),
                    Convert.ToInt32(DropDownList_Catalog.SelectedValue),
                    Convert.ToInt32(DropDownList_Category.SelectedValue)).ToList<Product>();
            }

            GridView_Products.DataSource = products;
            GridView_Products.AllowPaging = true;
            GridView_Products.PageSize = 10;
            GridView_Products.DataBind();

            Session["dataSource"] = GridView_Products.DataSource;
        }

        protected void grdTest_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.DataItem != null)
            {
                e.Row.Cells[9].Text = String.Format("{0:C}", Convert.ToDouble(e.Row.Cells[9].Text));
                if (e.Row.Cells[7].Text != "Active")
                {
                    e.Row.Cells[1].Text = string.Empty;
                }
            }

        }
    }
}