﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using CapstoneWebApplication.ServiceReference1;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class Checkout : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            Label_Confirmation.Visible = false;
            returnButton.Visible = false;
        }

        protected void Button_CheckoutCancel_Click(object sender, EventArgs e)
        {
            Response.Redirect("ShoppingCart.aspx");
        }

        protected void Button_CheckoutConfirm_Click(object sender, EventArgs e)
        {
            int clientID = (int)_dc.getWebUser(User.Identity.Name).Single().ClientID;

            ShoppingCart cart = (ShoppingCart)Session["shoppingCart"];

            WebServiceSoapClient webClient = new WebServiceSoapClient();

            int orderId = webClient.InsertOrder(clientID);

            List<CartItem> cartItems = cart.GetCartItems();

            foreach (CartItem item in cartItems)
            {
                webClient.InsertOrderDetail(orderId, item.Id, cart.GetQuantity(item));
            }

            Label_Confirmation.Visible = true;
            Label_Confirmation.Text = "Thank you.  Your order has been placed.  Your order id is " + orderId;

            Button_CheckoutCancel.Visible = false;
            Button_CheckoutConfirm.Visible = false;
            Label_SubmitOrder.Visible = false;

            Session["shoppingCart"] = new ShoppingCart();

            returnButton.Visible = true;
        }
    }
}