﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class EditAddress : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();
        int _addressID;
        int _contactID;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                loadAddress();
            }            
        }

        private void loadAddress()
        {
            try
            {
                _contactID = int.Parse(Request["contact"]);
                _addressID = int.Parse(Request["address"]);
            }
            catch
            {
                //maybe boot them back to the previous page?
                return;
            }

            Contact addressForContact = _dc.getContact(_contactID).Single();
            nameLabel.Text = addressForContact.Contact_Name;

            Address address = _dc.getAddress(_addressID).Single();

            //populate text box
            civicTextBox.Text = address.Civic_Address;
            cityTextBox.Text = address.City;
            provinceDropDownList.SelectedValue = address.Province;
            postalTextBox.Text = address.Postal_Code;

            //save addressID
            AddressIDHiddenField.Value = _addressID.ToString();
        }

        protected void saveButton_Click(object sender, EventArgs e)
        {
            //create address
            Address address = new Address();
            address.Address_ID = int.Parse(AddressIDHiddenField.Value);
            address.Address_Type = "Contact-WebEdit";
            address.City = cityTextBox.Text;
            address.Civic_Address = civicTextBox.Text;
            address.Postal_Code = postalTextBox.Text;
            address.Province = provinceDropDownList.SelectedValue;

            //save to DB
            _dc.updateAddress(
                address.Address_ID,
                address.Civic_Address,
                address.City,
                address.Province,
                address.Postal_Code,
                address.Address_Type);

            //report saved
            confirmLabel.Text = "Changes saved for " + AddressIDHiddenField.Value + ".";

            //ok, go back to contacts manager
            Response.Redirect("Contacts.aspx");
        }
    }
}