﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class EditContact : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //this is just me being cruel
                nameLabel.Text = _dc.getClient(_dc.getWebUser(User.Identity.Name).Single().ClientID).Single().Client_Name;
                loadInformation();
            }
        }

        private void loadInformation()
        {
            string edit = Request["edit"];
            if (edit != null)
            {
                //OK, let's load the exisiting info!
                int contactID = int.Parse(edit);
                Contact contact = _dc.getContact(contactID).Single();

                //contact
                nameTextBox.Text = contact.Contact_Name;
                eMailTextBox.Text = contact.Email;
                phoneTextBox.Text = contact.Phone_Number;
                faxTextBox.Text = contact.Fax_Number;
                notesTextBox.Text = contact.Notes;

                //save contact ID
                ContactIDHiddenField.Value = contactID.ToString();
                //save address ID
                AddressIDHiddenField.Value = contact.Address_ID.ToString();
            }
            else
            {
                confirmLabel.Text = "Failed to load contact information.";
            }
        }

        protected void saveButton_Click(object sender, EventArgs e)
        {
            //build contact
            Contact contact = new Contact();
            contact.Contact_ID = int.Parse(ContactIDHiddenField.Value);
            contact.Contact_Name = nameTextBox.Text;
            contact.Email = eMailTextBox.Text;
            contact.Phone_Number = phoneTextBox.Text;
            contact.Fax_Number = faxTextBox.Text;
            contact.Notes = notesTextBox.Text;
            contact.Address_ID = int.Parse(AddressIDHiddenField.Value);
            contact.Address_Address_ID = int.Parse(AddressIDHiddenField.Value);

            //save to db
            _dc.updateContact(
                contact.Contact_ID,
                contact.Contact_Name,
                contact.Email,
                contact.Phone_Number,
                contact.Fax_Number,
                contact.Notes,
                contact.Address_ID,
                contact.Address_Address_ID                                
                );

            //confirmation
            confirmLabel.Text = "Changes saved.";

            //OK, go back to the contacts manager
            Response.Redirect("Contacts.aspx");
        }
    }
}