﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class NewContact : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //this is just me being cruel
                nameLabel.Text = _dc.getClient(_dc.getWebUser(User.Identity.Name).Single().ClientID).Single().Client_Name;
            }
        }

        protected void saveButton_Click(object sender, EventArgs e)
        {
            //contact
            Contact contact = new Contact();
            contact.Contact_Name = nameTextBox.Text;
            contact.Email = eMailTextBox.Text;
            contact.Phone_Number = phoneTextBox.Text;
            contact.Fax_Number = faxTextBox.Text;
            contact.Notes = notesTextBox.Text;

            //create address
            Address address = new Address();
            address.Address_Type = "Contact-WebCreate";
            address.City = cityTextBox.Text;
            address.Civic_Address = civicTextBox.Text;
            address.Postal_Code = postalTextBox.Text;
            address.Province = provinceDropDownList.SelectedValue;

            //save to DB
            var insertAddressResult = _dc.insertAddress(
                address.Civic_Address,
                address.City,
                address.Province,
                address.Postal_Code,
                address.Address_Type
                );
            address.Address_ID = (int)insertAddressResult.ElementAt(0).ID;
            contact.Address_ID = address.Address_ID;
            contact.Address_Address_ID = address.Address_ID;
            
            //save contact
            var insertContactResult = _dc.insertContact(
                contact.Contact_Name,
                contact.Email,
                contact.Phone_Number,
                contact.Fax_Number,
                contact.Notes,
                contact.Address_ID,
                contact.Address_Address_ID
                );
            contact.Contact_ID = (int)insertContactResult.ElementAt(0).ID;

            //save to client-contacts join
            _dc.insertClientContact(_dc.getWebUser(User.Identity.Name).Single().ClientID, contact.Contact_ID);
            
            confirmLabel.Text = "Contact saved.";

            //OK, go back to the contacts manager
            Response.Redirect("Contacts.aspx");

        }
    }
}