﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class OrderDetails : System.Web.UI.Page
    {
        CWDataClassesDataContext _dc = new CWDataClassesDataContext();

        protected void Page_Load(object sender, EventArgs e)
        {
            List<getOrderDetailsResult> orderItems;


            string details = Request["details"];
            //load up the details!
            if (details != null)
            {
                int orderID = int.Parse(details);

                //you have to be the right client!
                int clientID = (int)_dc.getWebUser(User.Identity.Name).Single().ClientID;
                int orderClientID = _dc.getOrderBasic(orderID).Single().Client_ID;

                if (clientID == orderClientID)
                {
                    orderNumberLabel.Text = details;

                    

                    orderItems = _dc.getOrderDetails(orderID).ToList();

                    detailsGridView.DataSource = orderItems;
                    detailsGridView.DataBind();
                }
                else
                {
                    orderNumberLabel.Text = "**INVALID**";                
                }
            }
        }
        
        protected void detailsGridView_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            //replace underscores with spaces
            //http://stackoverflow.com/a/3758699/1736461
            if (e.Row.RowType == DataControlRowType.Header)
            {
                for (int i = 0; i < e.Row.Cells.Count; i++)
                {
                    e.Row.Cells[i].Text = e.Row.Cells[i].Text.Replace("_", " ");
                }
            }
            //format currency
            else if (e.Row.RowType == DataControlRowType.DataRow)
            {
                decimal productPrice = decimal.Parse(e.Row.Cells[4].Text.ToString());
                decimal totalPrice = decimal.Parse(e.Row.Cells[6].Text.ToString());

                e.Row.Cells[4].Text = String.Format("{0:C}", productPrice);
                e.Row.Cells[6].Text = String.Format("{0:C}", totalPrice);           
            }
        }
    }
}