﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using CapstoneWebApplication.ServiceReference1;

namespace CapstoneWebApplication.RegUserPages
{
    public partial class ShoppingCart1 : System.Web.UI.Page
    {
        protected ShoppingCart shoppingCart;

        protected void Page_Load(object sender, EventArgs e)
        {
            WebServiceSoapClient client = new WebServiceSoapClient();

            if (Session["shoppingCart"] == null)
            {
                shoppingCart = new ShoppingCart();
                Session["shoppingCart"] = shoppingCart;
            }
            else
            {
                shoppingCart = (ShoppingCart)Session["shoppingCart"];
            }

            if (Request.QueryString["id"] != null || Request.QueryString["addone"] != null)
            {
                int id;

                if (Request.QueryString["id"] != null)
                {
                    id = Convert.ToInt32(Request.QueryString["id"]);
                }
                else
                {
                    id = Convert.ToInt32(Request.QueryString["addone"]);
                }
                List<Product> products = client.GetProductByIdOnly(id).ToList<Product>();

                CartItem item = new CartItem();
                Product product = products[0];

                item.Id = product.Id;
                item.Name = product.Name;
                item.Description = product.Description;
                item.ManufacturingTime = product.ManufacturingTime;
                item.Status = product.Status;
                item.Price = product.Price;
                item.ImagePath = product.ImagePath;

                // only active products may be added
                if (item.Status != "Active")
                {
                    return;
                }

                shoppingCart.Add(item);
            }
            else if (Request.QueryString["remove"] != null) //remove all
            {
                int id = Convert.ToInt32(Request.QueryString["remove"]);
                shoppingCart.RemoveAll(id);
            }
            else if (Request.QueryString["removeone"] != null)
            {
                int id = Convert.ToInt32(Request.QueryString["removeone"]);
                shoppingCart.Remove(id);
            }

            if (!(shoppingCart.GetCartItems().Count > 0))
            {
                Button_Checkout.Visible = false;
            }
            else
            {
                Button_Checkout.Visible = true;
            }
        }

        protected void Button_Checkout_Click(object sender, EventArgs e)
        {
            Response.Redirect("Checkout.aspx");
        }

        protected void Button_ContinueShopping_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/Products.aspx");
        }
    }
}