﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;

using System.Data.SqlClient;namespace WebServiceApp
{
    /// <summary>
    /// Summary description for WebService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class WebService : System.Web.Services.WebService
    {
        private string connectionString = "Data Source=WIN-OA9TV4LURBG\\SQLEXPRESS;Initial Catalog=UnderGuardDb;Integrated Security=True";        
        
        [WebMethod]
        public List<Product> GetProductById(int productId, int catalogId, int categoryId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductById", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@CatalogId", catalogId));
            cmd.Parameters.Add(new SqlParameter("@CategoryId", categoryId));
            cmd.Parameters.Add(new SqlParameter("@ProductId", productId));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetProductByIdOnly(int productId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductByIdOnly", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@ProductId", productId));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetProductByName(string name, int catalogId, int categoryId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductByName", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@CatalogId", catalogId));
            cmd.Parameters.Add(new SqlParameter("@CategoryId", categoryId));
            cmd.Parameters.Add(new SqlParameter("@ProductName", name));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetProductByDescription(string description, int catalogId, int categoryId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductByDescription", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@CatalogId", catalogId));
            cmd.Parameters.Add(new SqlParameter("@CategoryId", categoryId));
            cmd.Parameters.Add(new SqlParameter("@ProductDescription", description));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetProductByStatus(string status, int catalogId, int categoryId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductByStatus", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@CatalogId", catalogId));
            cmd.Parameters.Add(new SqlParameter("@CategoryId", categoryId));
            cmd.Parameters.Add(new SqlParameter("@ProductStatus", status));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetProductByPrice(float price, int catalogId, int categoryId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetProductByPrice", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@CatalogId", catalogId));
            cmd.Parameters.Add(new SqlParameter("@CategoryId", categoryId));
            cmd.Parameters.Add(new SqlParameter("@ProductPrice", price));

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public List<Product> GetTop10ProductsFromMostRecentCatalog()
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_GetTop10ProductsFromMostRecentCatalog", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;

            conn.Open();

            SqlDataReader reader = cmd.ExecuteReader();

            List<Product> products = new List<Product>();

            while (reader.Read())
            {
                Product product = new Product();
                product.Id = (int)reader["Product_ID"];
                product.Name = (string)reader["Product_Name"];
                product.Description = (string)reader["Product_Description"];
                product.ManufacturingTime = (int)reader["Manufacturing_Time"];
                product.Status = (string)reader["CurrentStatus"];
                product.ImagePath = (string)reader["Image_Path"];
                product.Price = (double)reader["Price"];

                products.Add(product);
            }

            conn.Close();

            return products;
        }

        [WebMethod]
        public int InsertOrder(int clientId)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_InsertOrder", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@ClientId", clientId));

            conn.Open();

            int orderId = (int)cmd.ExecuteScalar();

            conn.Close();

            return orderId;
        }

        [WebMethod]
        public void InsertOrderDetail(int orderId, int productId, int qty)
        {
            SqlConnection conn = new SqlConnection(connectionString);

            SqlCommand cmd = new SqlCommand("AspFinal_InsertOrderDetail", conn);
            cmd.CommandType = System.Data.CommandType.StoredProcedure;
            cmd.Parameters.Add(new SqlParameter("@OrderId", orderId));
            cmd.Parameters.Add(new SqlParameter("@ProductId", productId));
            cmd.Parameters.Add(new SqlParameter("@Qty", qty));

            conn.Open();

            cmd.ExecuteNonQuery();

            conn.Close();
        }  
    }

    public class Product
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Description { get; set; }
        public int ManufacturingTime { get; set; }
        public string Status { get; set; }
        public string ImagePath { get; set; }
        public double Price { get; set; }
    }
}
